package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.entidad.SeguroKm;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.rjconsultores.ventaboletos.dao.SeguroKmDAO;
import com.rjconsultores.ventaboletos.service.SeguroKmService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import org.springframework.transaction.annotation.Transactional;

@Service("seguroKmService")
public class SeguroKmServiceImpl implements SeguroKmService {

    @Autowired
    private SeguroKmDAO seguroKmDAO;

    public List<SeguroKm> buscarPorOrgao(OrgaoConcedente orgao) {
        return seguroKmDAO.buscarPorOrgao(orgao);
    }

    public List<SeguroKm> obtenerTodos() {
        return seguroKmDAO.obtenerTodos();
    }

    public SeguroKm obtenerID(Integer id) {
        return seguroKmDAO.obtenerID(id);
    }

    @Transactional
    public SeguroKm suscribir(SeguroKm entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);
        
        return seguroKmDAO.suscribir(entidad);
    }

    @Transactional
    public SeguroKm actualizacion(SeguroKm entidad) {
        return seguroKmDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(SeguroKm entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);
        
        seguroKmDAO.borrar(entidad);
    }
}
